
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>老生常谈-从输入url到页面展示到底发生了什么 / iVAN</title>

    <meta name="description" content="老生常谈-从输入url到页面展示到底发生了什么 阅读目录 输入地址 浏览器查找域名的 IP 地址 浏览器向 web 服务器发送一个 HTTP 请求 服务器的永久重定向响应 浏览器跟踪重定向地址 服务器处理请求 服务器返回一个 HTTP 响应 浏览器显示 HTML 浏览器发送请求获取嵌入在 HTML 中的资源(如图片.音频.视频.CSS.JS等等) 刚开始写这篇文章还是挺纠结的,因为网上搜索&quot;从输入url到页面展示到底发生了什么&quot;,你可以搜到一大堆的资料.而且面试这道题基本是必考题,二月份面试的时候,虽然知道这个过程发生了什 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">老生常谈-从输入url到页面展示到底发生了什么</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>阅读目录</strong></p>
<ul>
<li>输入地址</li>
<li>浏览器查找域名的 IP 地址</li>
<li>浏览器向 web 服务器发送一个 HTTP 请求</li>
<li>服务器的永久重定向响应</li>
<li>浏览器跟踪重定向地址</li>
<li>服务器处理请求</li>
<li>服务器返回一个 HTTP 响应</li>
<li>浏览器显示 HTML</li>
<li>浏览器发送请求获取嵌入在 HTML 中的资源(如图片、音频、视频、CSS、JS等等)</li>
</ul>
<p>刚开始写这篇文章还是挺纠结的，因为网上搜索“从输入url到页面展示到底发生了什么”，你可以搜到一大堆的资料。而且面试这道题基本是必考题，二月份面试的时候，虽然知道这个过程发生了什么，不过当面试官一步步追问下去的，很多细节就不太清楚了。</p>
<p>最近刚好也在看http协议相关的东西，所以想对这个话题来个深入的总结，本文的目的是通过输入url之后发生的事情来做知识的总结和扩展。所以文章可能会很杂。</p>
<p>总的过程大概如下:</p>
<p><strong>1、输入地址</strong></p>
<p>当我们开始在浏览器中输入网址的时候，浏览器其实就已经在智能的匹配可能得 url<br />
了，他会从历史记录，书签等地方，找到已经输入的字符串可能对应的  url，然后给出智能提示，让你可以补全url地址。对于<br />
google的chrome 的浏览器，他甚至会直接从缓存中把网页展示出来，就是说，你还没有按下  enter，页面就出来了。</p>
<p><strong>2、浏览器查找域名的 IP 地址</strong></p>
<p>1)、请求一旦发起，浏览器首先要做的事情就是解析这个域名，一般来说，浏览器会首先查看本地硬盘的 hosts  文件，看看其中有没有和这个域名对应的规则，如果有的话就直接使用 hosts 文件里面的 ip 地址。</p>
<p>2)、如果在本地的 hosts 文件没有能够找到对应的 ip 地址，浏览器会发出一个 DNS请求到本地DNS服务器  。本地DNS服务器一般都是你的网络接入服务器商提供，比如中国电信，中国移动。</p>
<p>3)、查询你输入的网址的DNS请求到达本地DNS服务器之后，本地DNS服务器会首先查询它的缓存记录，如果缓存中有此条记录，就可以直接返回结果，此过程是递归的方式进行查询。如果没有，本地DNS服务器还要向DNS根服务器进行查询。</p>
<p>4)、根DNS服务器没有记录具体的域名和IP地址的对应关系，而是告诉本地DNS服务器，你可以到域服务器上去继续查询，并给出域服务器的地址。这种过程是迭代的过程。</p>
<p>5)、本地DNS服务器继续向域服务器发出请求，在这个例子中，请求的对象是.com域服务器。.com域服务器收到请求之后，也不会直接返回域名和IP地址的对应关系，而是告诉本地DNS服务器，你的域名的解析服务器的地址。</p>
<p>6)、最后，本地DNS服务器向域名的解析服务器发出请求，这时就能收到一个域名和IP地址对应关系，本地DNS服务器不仅要把IP地址返回给用户电脑，还要把这个对应关系保存在缓存中，以备下次别的用户查询时，可以直接返回结果，加快网络访问。</p>
<p>下面这张图很完美的解释了这一过程：  </p>
<p><a href="http://s4.51cto.com/wyfs02/M01/8F/C4/wKiom1jscHbwCYF5AAD_6QbyeGY499.jpg-wh_651x-s_2178260947.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDEvOEYvQzQvd0tpb20xanNjSGJ3Q1lGNUFBRF82UWJ5ZUdZNDk5LmpwZy13aF82NTF4LXNfMjE3ODI2MDk0Ny5qcGc=.jpg"></a></p>
<p><strong>知识扩展：</strong></p>
<p>1).什么是DNS?</p>
<p>DNS(Domain Name<br />
System，域名系统)，因特网上作为域名和IP地址相互映射的一个分布式数据库，能够使用户更方便的访问互联网，而不用去记住能够被机器直接读取的IP数串。通过主机名，最终得到该主机名对应的IP地址的过程叫做域名解析(或主机名解析)。</p>
<p>通俗的讲，我们更习惯于记住一个网站的名字，比如www.baidu.com,而不是记住它的ip地址，比如：167.23.10.2。而计算机更擅长记住网站的ip地址，而不是像www.baidu.com等链接。因为，DNS就相当于一个电话本，比如你要找www.baidu.com这个域名，那我翻一翻我的电话本，我就知道，哦，它的电话(ip)是167.23.10.2。</p>
<p>2).DNS查询的两种方式：递归查询和迭代查询</p>
<p>a、递归解析</p>
<p>当局部DNS服务器自己不能回答客户机的DNS查询时，它就需要向其他DNS服务器进行查询。此时有两种方式，如图所示的是递归方式。局部DNS服务器自己负责向其他DNS服务器进行查询，一般是先向该域名的根域服务器查询，再由根域名服务器一级级向下查询。最后得到的查询结果返回给局部DNS服务器，再由局部DNS服务器返回给客户端。  </p>
<p><a href="http://s2.51cto.com/wyfs02/M02/8F/C3/wKioL1jscLuD6WjzAABfQyiMgY4791.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOEYvQzMvd0tpb0wxanNjTHVENldqekFBQmZReWlNZ1k0NzkxLnBuZw==.jpg"></a></p>
<p>b、迭代解析</p>
<p>当局部DNS服务器自己不能回答客户机的DNS查询时，也可以通过迭代查询的方式进行解析，如图所示。局部DNS服务器不是自己向其他DNS服务器进行查询，而是把能解析该域名的其他DNS服务器的IP地址返回给客户端DNS程序，客户端DNS程序再继续向这些DNS服务器进行查询，直到得到查询结果为止。也就是说，迭代解析只是帮你找到相关的服务器而已，而不会帮你去查。比如说：baidu.com的服务器ip地址在192.168.4.5这里，你自己去查吧，本人比较忙，只能帮你到这里了。  </p>
<p><a href="http://s5.51cto.com/wyfs02/M02/8F/C4/wKiom1jscMWhSXgUAAAy8QDLafQ365.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczUuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOEYvQzQvd0tpb20xanNjTVdoU1hnVUFBQXk4UURMYWZRMzY1LmpwZw==.jpg"></a></p>
<p>3).DNS域名称空间的组织方式</p>
<p>我们在前面有说到根DNS服务器，域DNS服务器，这些都是DNS域名称空间的组织方式。按其功能命名空间中用来描述 DNS  域名称的五个类别的介绍详见下表中，以及与每个名称类型的示例</p>
<p><a href="http://s1.51cto.com/wyfs02/M00/8F/C3/wKioL1jscTqxKcDnAABmaN8H5aY183.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczEuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOEYvQzMvd0tpb0wxanNjVHF4S2NEbkFBQm1hTjhINWFZMTgzLmpwZw==.jpg"></a></p>
<p>(盗图)</p>
<p>4)DNS负载均衡</p>
<p>当一个网站有足够多的用户的时候，假如每次请求的资源都位于同一台机器上面，那么这台机器随时可能会蹦掉。处理办法就是用DNS负载均衡技术，它的原理是在DNS服务器中为同一个主机名配置多个IP地址,在应答DNS查询时,DNS服务器对每个查询将以DNS文件中主机记录的IP地址按顺序返回不同的解析结果,将客户端的访问引导到不同的机器上去,使得不同的客户端访问不同的服务器,从而达到负载均衡的目的｡例如可以根据每台机器的负载量，该机器离用户地理位置的距离等等。</p>
<p><strong>3、浏览器向 web 服务器发送一个 HTTP 请求</strong></p>
<p>拿到域名对应的IP地址之后，浏览器会以一个随机端口(1024&lt;端口&lt;65535)向服务器的WEB程序(常用的有httpd,nginx等)80端口发起TCP的连接请求。这个连接请求到达服务器端后(这中间通过各种路由设备，局域网内除外)，进入到网卡，然后是进入到内核的TCP/IP协议栈(用于识别该连接请求，解封包，一层一层的剥开)，还有可能要经过Netfilter防火墙(属于内核的模块)的过滤，最终到达WEB程序，最终建立了TCP/IP的连接。</p>
<p>TCP连接如图所示:  </p>
<p><a href="http://s4.51cto.com/wyfs02/M02/8F/C4/wKiom1jscVCj-gGjAADfQH0WMKg703.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOEYvQzQvd0tpb20xanNjVkNqLWdHakFBRGZRSDBXTUtnNzAzLmpwZw==.jpg"></a></p>
<p>建立了TCP连接之后，发起一个http请求。一个典型的 http request header 一般需要包括请求的方法，例如 GET 或者<br />
 POST  等，不常用的还有 PUT 和 DELETE 、HEAD、OPTION以及 TRACE 方法，一般的浏览器只能发起 GET 或者<br />
POST 请求。</p>
<p>客户端向服务器发起http请求的时候，会有一些请求信息，请求信息包含三个部分：</p>
<p>| 请求方法URI协议/版本</p>
<p>| 请求头(Request Header)</p>
<p>| 请求正文：</p>
<p>下面是一个完整的HTTP请求例子：</p>
<pre>
</pre>
<ol>
<li>GET/sample.jspHTTP/1.1   Accept:image/gif.image/jpeg,*/*    </li>
<li>Accept-Language:zh-cn    </li>
<li>Connection:Keep-Alive    </li>
<li>Host:localhost    </li>
<li>User-Agent:Mozila/4.0(compatible;MSIE5.01;Window NT5.0)    </li>
<li>Accept-Encoding:gzip,deflate    </li>
<li> </li>
<li>username=jinqiao&amp;password=1234  </li>
</ol>
<p>注意：最后一个请求头之后是一个空行，发送回车符和换行符，通知服务器以下不再有请求头。</p>
<p>(1)请求的第一行是“方法URL议/版本”：GET/sample.jsp HTTP/1.1</p>
<p>(2)请求头(Request Header)</p>
<p>请求头包含许多有关的客户端环境和请求正文的有用信息。例如，请求头可以声明浏览器所用的语言，请求正文的长度等。</p>
<pre>
</pre>
<ol>
<li>Accept:image/gif.image/jpeg.*/*    </li>
<li>Accept-Language:zh-cn    </li>
<li>Connection:Keep-Alive    </li>
<li>Host:localhost    </li>
<li>User-Agent:Mozila/4.0(compatible:MSIE5.01:Windows NT5.0)    </li>
<li>Accept-Encoding:gzip,deflate.  </li>
</ol>
<p>(3)请求正文</p>
<p>请求头和请求正文之间是一个空行，这个行非常重要，它表示请求头已经结束，接下来的是请求正文。请求正文中可以包含客户提交的查询字符串信息：</p>
<pre>
</pre>
<ol>
<li>username=jinqiao&amp;password=1234 </li>
</ol>
<p><strong>知识扩展：</strong></p>
<p>1)TCP三次握手</p>
<p>第一次握手：客户端A将标志位SYN置为1,随机产生一个值为seq=J(J的取值范围为=1234567)的数据包到服务器，客户端A进入SYN_SENT状态，等待服务端B确认;</p>
<p>第二次握手：服务端B收到数据包后由标志位SYN=1知道客户端A请求建立连接，服务端B将标志位SYN和ACK都置为1，ack=J+1，随机产生一个值seq=K，并将该数据包发送给客户端A以确认连接请求，服务端B进入SYN_RCVD状态。</p>
<p>第三次握手：客户端A收到确认后，检查ack是否为J+1，ACK是否为1，如果正确则将标志位ACK置为1，ack=K+1，并将该数据包发送给服务端B，服务端B检查ack是否为K+1，ACK是否为1，如果正确则连接建立成功，客户端A和服务端B进入ESTABLISHED状态，完成三次握手，随后客户端A与服务端B之间可以开始传输数据了。</p>
<p>如图所示：  </p>
<p><a href="http://s1.51cto.com/wyfs02/M00/8F/C3/wKioL1jscZKglvulAABEiLLzjTI746.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczEuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOEYvQzMvd0tpb0wxanNjWktnbHZ1bEFBQkVpTEx6alRJNzQ2LnBuZw==.jpg"></a></p>
<p>2)为什需要三次握手?</p>
<p>《计算机网络》第四版中讲“三次握手”的目的是“为了防止已失效的连接请求报文段突然又传送到了服务端，因而产生错误”</p>
<p>书中的例子是这样的，“已失效的连接请求报文段”的产生在这样一种情况下：client发出的第一个连接请求报文段并没有丢失，而是在某个网络结点长时间的滞留了，以致延误到连接释放以后的某个时间才到达server。本来这是一个早已失效的报文段。但server收到此失效的连接请求报文段后，就误认为是client再次发出的一个新的连接请求。于是就向client发出确认报文段，同意建立连接</p>
<p>假设不采用“三次握手”，那么只要server发出确认，新的连接就建立了。由于现在client并没有发出建立连接的请求，因此不会理睬server的确认，也不会向server发送数据。但server却以为新的运输连接已经建立，并一直等待client发来数据。这样，server的很多资源就白白浪费掉了。采用“三次握手”的办法可以防止上述现象发生。例如刚才那种情况，client不会向server的确认发出确认。server由于收不到确认，就知道client并没有要求建立连接。”。主要目的防止server端一直等待，浪费资源。</p>
<p>3)TCP四次挥手</p>
<p>第一次挥手：Client发送一个FIN，用来关闭Client到Server的数据传送，Client进入FIN_WAIT_1状态。</p>
<p>第二次挥手：Server收到FIN后，发送一个ACK给Client，确认序号为收到序号+1(与SYN相同，一个FIN占用一个序号)，Server进入CLOSE_WAIT状态。</p>
<p>第三次挥手：Server发送一个FIN，用来关闭Server到Client的数据传送，Server进入LAST_ACK状态。</p>
<p>第四次挥手：Client收到FIN后，Client进入TIME_WAIT状态，接着发送一个ACK给Server，确认序号为收到序号+1，Server进入CLOSED状态，完成四次挥手。  </p>
<p><a href="http://s4.51cto.com/wyfs02/M01/8F/C5/wKiom1jscZ6xcG1SAABE9CaehGA930.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDEvOEYvQzUvd0tpb20xanNjWjZ4Y0cxU0FBQkU5Q2FlaEdBOTMwLnBuZw==.jpg"></a></p>
<p>4)为什么建立连接是三次握手，而关闭连接却是四次挥手呢?</p>
<p>这是因为服务端在LISTEN状态下，收到建立连接请求的SYN报文后，把ACK和SYN放在一个报文里发送给客户端。而关闭连接时，当收到对方的FIN报文时，仅仅表示对方不再发送数据了但是还能接收数据，己方也未必全部数据都发送给对方了，所以己方可以立即close，也可以发送一些数据给对方后，再发送FIN报文给对方来表示同意现在关闭连接，因此，己方ACK和FIN一般都会分开发送。</p>
<p><strong>4、服务器的永久重定向响应</strong></p>
<p>服务器给浏览器响应一个301永久重定向响应，这样浏览器就会访问“http://www.google.com/”  而非“http://google.com/”。</p>
<p>为什么服务器一定要重定向而不是直接发送用户想看的网页内容呢?其中一个原因跟搜索引擎排名有关。如果一个页面有两个地址，就像http://www.yy.com/和http://yy.com/，搜索引擎会认为它们是两个网站，结果造成每个搜索链接都减少从而降低排名。而搜索引擎知道301永久重定向是什么意思，这样就会把访问带www的和不带www的地址归到同一个网站排名下。还有就是用不同的地址会造成缓存友好性变差，当一个页面有好几个名字时，它可能会在缓存里出现好几次。</p>
<p><strong>扩展知识</strong></p>
<p>1)301和302的区别。</p>
<p>301和302状态码都表示重定向，就是说浏览器在拿到服务器返回的这个状态码后会自动跳转到一个新的URL地址，这个地址可以从响应的Location首部中获取(用户看到的效果就是他输入的地址A瞬间变成了另一个地址B)——这是它们的共同点。</p>
<p>他们的不同在于。301表示旧地址A的资源已经被永久地移除了(这个资源不可访问了)，搜索引擎在抓取新内容的同时也将旧的网址交换为重定向之后的网址;</p>
<p>302表示旧地址A的资源还在(仍然可以访问)，这个重定向只是临时地从旧地址A跳转到地址B，搜索引擎会抓取新的内容而保存旧的网址。  SEO302好于301</p>
<p>2)重定向原因：</p>
<p>(1)网站调整(如改变网页目录结构);</p>
<p>(2)网页被移到一个新地址;</p>
<p>(3)网页扩展名改变(如应用需要把.php改成.Html或.shtml)。</p>
<p>这种情况下，如果不做重定向，则用户收藏夹或搜索引擎数据库中旧地址只能让访问客户得到一个404页面错误信息，访问流量白白丧失;再者某些注册了多个域名的网站，也需要通过重定向让访问这些域名的用户自动跳转到主站点等。</p>
<p>3)什么时候进行301或者302跳转呢?</p>
<p>当一个网站或者网页24—48小时内临时移动到一个新的位置，这时候就要进行302跳转，而使用301跳转的场景就是之前的网站因为某种原因需要移除掉，然后要到新的地址访问，是永久性的。</p>
<p>清晰明确而言：使用301跳转的大概场景如下：</p>
<ul>
<li>域名到期不想续费(或者发现了更适合网站的域名)，想换个域名。</li>
<li>在搜索引擎的搜索结果中出现了不带www的域名，而带www的域名却没有收录，这个时候可以用301重定向来告诉搜索引擎我们目标的域名是哪一个。</li>
<li>空间服务器不稳定，换空间的时候。</li>
<li>浏览器跟踪重定向地址</li>
</ul>
<p>现在浏览器知道了 "http://www.google.com/"才是要访问的正确地址，所以它会发送另一个http请求。这里没有啥好说的</p>
<ul>
<li>服务器处理请求</li>
</ul>
<p>经过前面的重重步骤，我们终于将我们的http请求发送到了服务器这里，其实前面的重定向已经是到达服务器了，那么，服务器是如何处理我们的请求的呢?</p>
<p>后端从在固定的端口接收到TCP报文开始，它会对TCP连接进行处理，对HTTP协议进行解析，并按照报文格式进一步封装成HTTP  Request对象，供上层使用。</p>
<p>一些大一点的网站会将你的请求到反向代理服务器中，因为当网站访问量非常大，网站越来越慢，一台服务器已经不够用了。于是将同一个应用部署在多台服务器上，将大量用户的请求分配给多台机器处理。此时，客户端不是直接通过HTTP协议访问某网站应用服务器，而是先请求到Nginx，Nginx再请求应用服务器，然后将结果返回给客户端，这里Nginx的作用是反向代理服务器。同时也带来了一个好处，其中一台服务器万一挂了，只要还有其他服务器正常运行，就不会影响用户使用。</p>
<p>如图所示： </p>
<p><a href="http://s3.51cto.com/wyfs02/M00/8F/C5/wKiom1jsceHycS1QAAD0i1j5kGE017.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOEYvQzUvd0tpb20xanNjZUh5Y1MxUUFBRDBpMWo1a0dFMDE3LmpwZw==.jpg"></a></p>
<p>通过Nginx的反向代理，我们到达了web服务器，服务端脚本处理我们的请求，访问我们的数据库，获取需要获取的内容等等，当然，这个过程涉及很多后端脚本的复杂操作。由于对这一块不熟，所以这一块只能介绍这么多了。</p>
<p><strong>扩展阅读：</strong></p>
<p>1)什么是反向代理?</p>
<p>客户端本来可以直接通过HTTP协议访问某网站应用服务器，网站管理员可以在中间加上一个Nginx，客户端请求Nginx，Nginx请求应用服务器，然后将结果返回给客户端，此时Nginx就是反向代理服务器。 </p>
<p><a href="http://s4.51cto.com/wyfs02/M02/8F/C5/wKiom1jscf3ByozQAAD0i6qWoHo415.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOEYvQzUvd0tpb20xanNjZjNCeW96UUFBRDBpNnFXb0hvNDE1LmpwZw==.jpg"></a></p>
<p><strong>7、服务器返回一个 HTTP 响应</strong></p>
<p>经过前面的6个步骤，服务器收到了我们的请求，也处理我们的请求，到这一步，它会把它的处理结果返回，也就是返回一个HTPP响应。</p>
<p>HTTP响应与HTTP请求相似，HTTP响应也由3个部分构成，分别是：</p>
<p>l 状态行</p>
<p>l 响应头(Response Header)</p>
<p>l 响应正文</p>
<pre>
</pre>
<ol>
<li>HTTP/1.1 200 OK    </li>
<li>Date: Sat, 31 Dec 2005 23:59:59 GMT    </li>
<li>Content-Type: text/html;charset=ISO-8859-1   Content-Length: 122   ＜html＞    </li>
<li>＜head＞    </li>
<li>＜title＞http＜/title＞    </li>
<li>＜/head＞    </li>
<li>＜body＞    </li>
<li>＜!-- body goes here --＞    </li>
<li>＜/body＞    </li>
<li>＜/html＞  </li>
</ol>
<p>状态行：</p>
<p>状态行由协议版本、数字形式的状态代码、及相应的状态描述，各元素之间以空格分隔。</p>
<p>格式: HTTP-Version Status-Code Reason-Phrase CRLF</p>
<p>例如: HTTP/1.1 200 OK \r\n</p>
<p>-- 协议版本：是用http1.0还是其他版本</p>
<p>-- 状态描述：状态描述给出了关于状态代码的简短的文字描述。比如状态代码为200时的描述为 ok</p>
<p>-- 状态代码：状态代码由三位数字组成，第一个数字定义了响应的类别，且有五种可能取值。如下</p>
<p>1xx：信息性状态码，表示服务器已接收了客户端请求，客户端可继续发送请求。</p>
<p>100 Continue</p>
<p>101 Switching Protocols</p>
<p>2xx：成功状态码，表示服务器已成功接收到请求并进行处理。200 OK 表示客户端请求成功</p>
<p>204 No Content 成功，但不返回任何实体的主体部分</p>
<p>206 Partial Content 成功执行了一个范围(Range)请求</p>
<p>3xx：重定向状态码，表示服务器要求客户端重定向。</p>
<p>301 Moved Permanently 永久性重定向，响应报文的Location首部应该有该资源的新URL</p>
<p>302 Found 临时性重定向，响应报文的Location首部给出的URL用来临时定位资源</p>
<p>303 See Other 请求的资源存在着另一个URI，客户端应使用GET方法定向获取请求的资源</p>
<p>304 Not Modified 服务器内容没有更新，可以直接读取浏览器缓存</p>
<p>307 Temporary Redirect 临时重定向。与302  Found含义一样。302禁止POST变换为GET，但实际使用时并不一定，307则更多浏览器可能会遵循这一标准，但也依赖于浏览器具体实现</p>
<p>4xx：客户端错误状态码，表示客户端的请求有非法内容。</p>
<p>400 Bad Request 表示客户端请求有语法错误，不能被服务器所理解</p>
<p>401 Unauthonzed 表示请求未经授权，该状态代码必须与 WWW-Authenticate 报头域一起使用</p>
<p>403 Forbidden 表示服务器收到请求，但是拒绝提供服务，通常会在响应正文中给出不提供服务的原因</p>
<p>404 Not Found 请求的资源不存在，例如，输入了错误的URL</p>
<p>5xx：服务器错误状态码，表示服务器未能正常处理客户端的请求而出现意外错误。</p>
<p>500 Internel Server Error 表示服务器发生不可预期的错误，导致无法完成客户端的请求</p>
<p>503 Service Unavailable 表示服务器当前不能够处理客户端的请求，在一段时间之后，服务器可能会恢复正常</p>
<p>响应头：</p>
<p>响应头部：由关键字/值对组成，每行一对，关键字和值用英文冒号":"分隔，典型的响应头有：  </p>
<p><a href="http://s4.51cto.com/wyfs02/M02/8F/C5/wKiom1jsciixDFGMAAKrZkcUz1g962.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOEYvQzUvd0tpb20xanNjaWl4REZHTUFBS3Jaa2NVejFnOTYyLmpwZw==.jpg"></a></p>
<p>响应正文</p>
<p>包含着我们需要的一些具体信息，比如cookie，html,image，后端返回的请求数据等等。这里需要注意，响应正文和响应头之间有一行空格，表示响应头的信息到空格为止，下图是fiddler抓到的请求正文，红色框中的：响应正文：</p>
<p><a href="http://s2.51cto.com/wyfs02/M02/8F/C3/wKioL1jscjzQegZgAADgHJ0OVq8794.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOEYvQzMvd0tpb0wxanNjanpRZWdaZ0FBRGdISjBPVnE4Nzk0LnBuZw==.jpg"></a> <br />
<br /><strong>8、浏览器显示 HTML</strong></p>
<p>在浏览器没有完整接受全部HTML文档时，它就已经开始显示这个页面了，浏览器是如何把页面呈现在屏幕上的呢?不同浏览器可能解析的过程不太一样，这里我们只介绍webkit的渲染过程，下图对应的就是WebKit渲染的过程，这个过程包括：</p>
<p>解析html以构建dom树 -&gt; 构建render树 -&gt; 布局render树 -&gt; 绘制render树 </p>
<p><a href="http://s5.51cto.com/wyfs02/M00/8F/C5/wKiom1jscknhCStFAACVx4m61oc178.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczUuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOEYvQzUvd0tpb20xanNja25oQ1N0RkFBQ1Z4NG02MW9jMTc4LmpwZw==.jpg"></a></p>
<p>浏览器在解析html文件时，会”自上而下“加载，并在加载过程中进行解析渲染。在解析过程中，如果遇到请求外部资源时，如图片、外链的CSS、iconfont等，请求过程是异步的，并不会影响html文档进行加载。</p>
<p>解析过程中，浏览器首先会解析HTML文件构建DOM树，然后解析CSS文件构建渲染树，等到渲染树构建完成后，浏览器开始布局渲染树并将其绘制到屏幕上。这个过程比较复杂，涉及到两个概念:  reflow(回流)和repain(重绘)。</p>
<p>DOM节点中的各个元素都是以盒模型的形式存在，这些都需要浏览器去计算其位置和大小等，这个过程称为relow;当盒模型的位置,大小以及其他属性，如颜色,字体,等确定下来之后，浏览器便开始绘制内容，这个过程称为repain。</p>
<p>页面在首次加载时必然会经历reflow和repain。reflow和repain过程是非常消耗性能的，尤其是在移动设备上，它会破坏用户体验，有时会造成页面卡顿。所以我们应该尽可能少的减少reflow和repain。</p>
<p><a href="http://s4.51cto.com/wyfs02/M01/8F/C5/wKiom1jscoSz9mUKAAC9K6IdFfM462.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDEvOEYvQzUvd0tpb20xanNjb1N6OW1VS0FBQzlLNklkRmZNNDYyLnBuZw==.jpg"></a></p>
<p>当文档加载过程中遇到js文件，html文档会挂起渲染(加载解析渲染同步)的线程，不仅要等待文档中js文件加载完毕，还要等待解析执行完毕，才可以恢复html文档的渲染线程。因为JS有可能会修改DOM，最为经典的document.write，这意味着，在JS执行完成前，后续所有资源的下载可能是没有必要的，这是js阻塞后续资源下载的根本原因。所以我明平时的代码中，js是放在html文档末尾的。</p>
<p>JS的解析是由浏览器中的JS解析引擎完成的，比如谷歌的是V8。JS是单线程运行，也就是说，在同一个时间内只能做一件事，所有的任务都需要排队，前一个任务结束，后一个任务才能开始。但是又存在某些任务比较耗时，如IO读写等，所以需要一种机制可以先执行排在后面的任务，这就是：同步任务(synchronous)和异步任务(asynchronous)。</p>
<p>JS的执行机制就可以看做是一个主线程加上一个任务队列(task<br />
queue)。同步任务就是放在主线程上执行的任务，异步任务是放在任务队列中的任务。所有的同步任务在主线程上执行，形成一个执行栈;异步任务有了运行结果就会在任务队列中放置一个事件;脚本运行时先依次运行执行栈，然后会从任务队列里提取事件，运行任务队列中的任务，这个过程是不断重复的，所以又叫做事件循环(Event<br />
  loop)。具体的过程可以看我这篇文章：点击这里</p>
<p><strong>9、浏览器发送请求获取嵌入在 HTML 中的资源(如图片、音频、视频、CSS、JS等等)</strong></p>
<p>其实这个步骤可以并列在步骤8中，在浏览器显示HTML时，它会注意到需要获取其他地址内容的标签。这时，浏览器会发送一个获取请求来重新获得这些文件。比如我要获取外图片，CSS，JS文件等，类似于下面的链接：</p>
<p>图片：http://static.ak.fbcdn.net/rsrc.php/z12E0/hash/8q2anwu7.gif</p>
<p>CSS式样表：http://static.ak.fbcdn.net/rsrc.php/z448Z/hash/2plh8s4n.css</p>
<p>JavaScript 文件：http://static.ak.fbcdn.net/rsrc.php/zEMOA/hash/c8yzb6ub.js</p>
<p>这些地址都要经历一个和HTML读取类似的过程。所以浏览器会在DNS中查找这些域名，发送请求，重定向等等...</p>
<p>不像动态页面，静态文件会允许浏览器对其进行缓存。有的文件可能会不需要与服务器通讯，而从缓存中直接读取，或者可以放到CDN中</p>
<p>------------分割线------------</p>
<p>至此，从输入url到页面展示的过程终于整理完了。本文前前后后整理了差不多一个星期，当然，网上有很多文章的顺序可能跟本文不太一样，也是可以的。</p>
<p>如今已离开呆了一年的大YY，进入了另一家公司，有很多东西在后面等着学习，有点小压力的同时也有很强烈的兴奋，哈哈。愿你在金三银四里找到满意的工作，干巴爹。</p>
<p>当然，文笔有限，有误之处，欢迎指出，本文参考了很多的文章，不过很多文章的链接不记得了，所以只列出了下面三个参考链接。</p>
<p>作者：咸鱼老弟</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 07:47:46</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b5%8f%e8%a7%88%e5%99%a8/" title="浏览器">浏览器</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e5%9f%9f%e5%90%8d/" title="域名">域名</a>, <a href="https://www.iamivan.net/tag/http/" title="http">http</a>, <a href="https://www.iamivan.net/tag/server/" title="server">server</a>, <a href="https://www.iamivan.net/tag/url/" title="url">url</a>, <a href="https://www.iamivan.net/tag/dns/" title="dns">dns</a>, <a href="https://www.iamivan.net/tag/%e6%90%9c%e7%b4%a2%e5%bc%95%e6%93%8e/" title="搜索引擎">搜索引擎</a>, <a href="https://www.iamivan.net/tag/%e5%ba%94%e7%94%a8%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="应用服务器">应用服务器</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>老生常谈-从输入url到页面展示到底发生了什么的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWllLnp.html" rel="bookmark">从输入URL到页面显示的过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://igoro.com/archive/what-really-happens-when-you-navigate-to-a-url/ http://www.cnblogs.com/wenanry/archive/2010/02/25/1673368.html http://www.jianshu.com/p/d9361badf49a 当在浏览器中输入一个url后回车,后台发生了什么?比如输入url后,你看到了百度的首页,那么这一切是如何发生的呢? 作为一个软件开发者,你一定会对网络应			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjL5d0p.html" rel="bookmark">从输入 URL 到页面加载完成的过程中都发生了什么事情&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				wuduoyi.com 背景 本文来自于之前我发的一篇微博: 不过写这篇文章并不是为了帮大家准备面试,而是想借这道题来介绍计算机和互联网的基础知识,让读者了解它们之间是如何关联起来的. 为了便于理解,我将整个过程分为了六个问题来展开. 第一个问题:从输入 URL 到浏览器接收的过程中发生了什么事情? 从触屏到 CPU 首先是「输入 URL」,大部分人的第一反应会是键盘,不过为了与时俱进,这里将介绍触摸屏设备的交互. 触摸屏一种传感器,目前大多是基于电容(Capacitive)来实现的,以前都是直			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0Qwg8p.html" rel="bookmark">从一道百度面试题到分析输入url到页面返回的过程（或者查询返回过程）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近看到一个题目,是当在浏览器中输入一个url后回车,后台发生了什么?比如输入url后,你看到了百度的首页,那么这一切是如何发生的呢? 这个问题之前.最近.我想以后肯定还会被问到,或者问到这样的题目,如果在百度框里输入查询的字符串开始,是怎么返回你需要的东西呢. 那这什么个过程呢(这个问题我在之后的博客中在写)? 网上各种的说法,不外乎这么几种 第一种简单的说呢就是这样的: 第一步:客户机提出域名解析请求,并将该请求发送给本地的域名服务器. 第二步:当本地的域名服务器收到请求后,就先查询本地的缓			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnYa3OM.html" rel="bookmark">TCP三次握手&amp;amp&semi;Render Tree页面渲染&equals;&amp;gt&semi;从输入URL到页面显示的过程？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近工作之余一直在温故js系列,想知新,想提升,以小技术点为节奏去回顾.今天突然想到回顾一下这个http知识,http知识有太多深层次需要学习,今天简要回顾,浅析下这个技术点. 主要通过五个步骤浅析这个过程,有错误的地方,烦请斧正,互相学习. 艾玛,我只是浅析一下,深析请见:http://fex.baidu.com/blog/201... 这个知识太复杂了,以前看的时候头晕O(∩_∩)O~ 1.发送URL,请求IP地址 当发送一个URL请求时,不管这个URL是Web页面的URL还是Web页面上每			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxWxVRb.html" rel="bookmark">百度面试题：从输入url到显示网页，后台发生了什么？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				参考http://igoro.com/archive/what-really-happens-when-you-navigate-to-a-url/ http://www.cnblogs.com/wenanry/archive/2010/02/25/1673368.html 原文:http://igoro.com/archive/what-really-happens-when-you-navigate-to-a-url/ 作为一个软件开发者,你一定会对网络应用如何工作有一个完整的层次化的认知,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OM9x3Xb.html" rel="bookmark">输入URL之后都发生了什么</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				输入URL之后都发生了什么 这个标题印象中已经有很多讨论了.也来说说这个话题. 从头开始,当你的电脑使用网线连接到网络的时候,我们都知道,这个时候你的电脑会获取一个IP,这个IP就是你的唯一标识了.好了继续,你在浏览器中敲入了http://www.sina.com,开始你的网络之旅.那么这个时候问题来了,我们都知道你这个数据是从哪里的机器来的呢?比如sina的提供这个服务的机器也有个IP,那么你敲入的www.sina.com怎么会定位到sina提供机器的IP呢?这里就是DNS概念了. DNS 好			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0bogPEb.html" rel="bookmark">IIS自定义404错误，输入URL地址的小技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iis|错误|技巧 我设置IIS中自定义404错误,无法输入URL地址,总是提示输入&quot;错误的URL地址,请输入一个站点的绝对url地址&quot;. 我输入的是:http://www.xxxx.com/404.htm,但是每次都是错误. 反复测试了很多次,并且查询了网上的资料,发现:IIS设置404错误的时候,输入URL地址,要输入一个本站站点的绝对url地址,并不是网络上的一个域名地址. 具体设置如下:打开IIS管理器--&gt;点击要设置自定义404网点的属性--&gt;点击自定义错误选项-			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvGy7rp.html" rel="bookmark">&amp;quot&semi;天龙八步&amp;quot&semi;&semi;细说浏览器输入URL后发生了什么</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文摘要: 1.DNS域名解析: 2.建立TCP连接: 3.发送HTTP请求: 4.服务器处理请求: 5.返回响应结果: 6.关闭TCP连接: 7.浏览器解析HTML: 8.浏览器布局渲染: 总结 当我们在浏览器输入网址并回车后,一切从这里开始. 一.DNS域名解析 我们在浏览器输入网址,其实就是要向服务器请求我们想要的页面内容,所有浏览器首先要确认的是域名所对应的服务器在哪里.将域名解析成对应的服务器IP地址这项工作,是由DNS服务器来完成的. 客户端收到你输入的域名地址后,它首先去找本地的h			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/5zOlx3b.html" rel="bookmark">web设计-web页面展示-层级关系</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 web页面展示-层级关系 在web页面除了树形结构.还有什么结构可以展现层级关系,现在主流是什么? 解决方案 其实比起树结构,我觉得用图结构来描述web页面更为合适~只要都是对链表数据结构的具体使用.当然,图结构中还可以用邻接矩阵存储节点关系~ 解决方案二: 最典型的也就是图结了			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpd5Pdz.html" rel="bookmark" class="title">手机上J2ME的3D编程－简单创建3D立方体（1）</a>
					<div>
						编程|创建 参考文档:JSR-184 工具:Eclipse3.0+Eclipseme API:Mobile 3D Graphics API 模拟器:Sony Ericsson 分析: 在现实生活中,我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPq7qz.html" rel="bookmark" class="title">C&num;委托</a>
					<div>
						    函数重载 相同的函数名相同的签名是错误的,但是相同的函数名不同的签名是可行的. 委托 引用存储为函数的类型.生命使用delegate关键字,指定一个函数的签名,包含一个返回类型和参数列表.定义 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv1R8b.html" rel="bookmark" class="title">关于动态生成控件和动态获得控件的句柄值</a>
					<div>
						动态|控件 从问题者的发的贴子:help me里面需要动态获得控件的句柄值,这些日子在vs.net里试了一下,总结出一点点经验,如下:1.动态生成控件:不管是在asp.net里还是在windows a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk27DEM.html" rel="bookmark" class="title">Office 2013安装更简便 无需25位许可证密匙</a>
					<div>
						如果你已经下载了Office 2013的客户预览版版本,应该会注意到新版本的Office在安装上与之前的不同.因为Click-to-Run v2.0的存在,用户可以用非常简单和现代的方法来安装Offi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2y9YVz.html" rel="bookmark" class="title">Struts 2的基石&mdash;&mdash;拦截器（Interceptor）</a>
					<div>
						如果大家希望快速开发,一个类似Struts 2这样的简单方便的WEB框架必不可少.我们在开发DEMO使用的还是Struts 1.2.8,而且没有不使用任何EL(表达式语言),导致页面出现无数类似&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PJVPM.html" rel="bookmark" class="title">WPS2016如何使用格式刷</a>
					<div>
						  1.打开需要使用格式刷的文档 2.点击需要使用格式刷的内容,这里以有边框的内容为例,选中有边框的内容然后点击&quot;格式刷&quot;,接着点击需要使用格式化的内容 3.这个时候你就会发现选中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj74dWM.html" rel="bookmark" class="title">搜狗浏览器界面怎么自定义设置？</a>
					<div>
						  搜狗浏览器是不少电脑用户都在使用的浏览器,这款浏览器为用户提供了非常多个性化的设置,比如说,搜狗浏览器的界面是可以根据用户的使用习惯进行显示跟布局的.那么,搜狗浏览器的界面怎么进行自定义呢?相信不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24PmQp.html" rel="bookmark" class="title">酷盘可以自由重命名或移动共享文件夹吗</a>
					<div>
						  酷盘共享的文件夹默认存放于酷盘根目录,可以自由的将接收到的共享文件夹重命名或将其移动到其他非共享文件夹内,并不会造成任何影响. 需要提醒用户注意的是: 1.在网站和手机客户端上,共享的文件夹A不能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1dW7b.html" rel="bookmark" class="title">显卡测试软件哪个好</a>
					<div>
						  1.GPU-Z(最常用的显卡性能测试工具) 说起处理器识别工具CPU-Z,其知名度和必备度无需赘言.硬件网站TechPowerUp现在又提供了一个类似的工具GPU-Z,用于识别显卡.GPU-Z是一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBn4Oz.html" rel="bookmark" class="title">老毛桃U盘启动盘制作工具2013版使用教程</a>
					<div>
						系统文件一般有二种格式:ISO格式和GHO格式.ISO格式又分为原版系统和GHOST封装系统二种.只要用解压软件WinRAR解压后有大于600M(WIN7一般2G)以上的GHO文件的,是GHOST封装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXqvAp.html" rel="bookmark" class="title">U盘使用宝典</a>
					<div>
						  1.U盘只能作为临时拷贝文件使用(备份用的移动硬盘除外),不要长期存放重要文件或直接打开编辑,U盘存储载体属电子闪存,容易造成文件丢失,对于拷贝的重要文件使用后应及时删除,并将U盘及时拔下,不要长 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9ErxkM.html" rel="bookmark" class="title">Unity3D资源分享</a>
					<div>
						 都是网上找的连七八糟的资料了,整理好分享的,有学习资料,视频,源码,插件--等等 东西比较多,不是所有的都是你需要的,可以按  ctrl+F 来搜索你要的东西,如果有广告,不用理会,关掉就可以了,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72VP4p.html" rel="bookmark" class="title">link可以通过发射获得抽象类的方法（非抽象）的地址，并且实现调用么？</a>
					<div>
						问题描述 link可以通过发射获得抽象类的方法(非抽象)的地址,并且实现调用么? link可以通过发射获得抽象类的方法(非抽象)的地址,并且实现调用么? 解决方案 可以通过反射得到IL Opcodes ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjrvep.html" rel="bookmark" class="title">php之readdir函数用法实例&lowbar;php技巧</a>
					<div>
						本文实例讲述了php中readdir函数用法.分享给大家供大家参考.具体用法分析如下: 定义和用法:readdir() 函数返回由 opendir() 打开的目录句柄中的条目,若成功,则该函数返回一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPPomp.html" rel="bookmark" class="title">多个按钮依次在一个窗口中打开多个链接</a>
					<div>
						问题描述 现在我的主界面上有多个按钮,都是submit的.点击一个在新的页面出现链接,然后点击别的按钮,都是在刚才新打开的页面中显示相应的内容.当那个页面关闭的后,再点击按钮,在新的页面显示.请问这部 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQWQDp.html" rel="bookmark" class="title">DB2创建数据库常用参数详解&lpar;原创&rpar;</a>
					<div>
						本文只介绍DB2 create database语法中的常用参数 http://publib.boulder.ibm.com/infocenter/db2luw/v9/index.jsp  CREAT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRq7Vkb.html" rel="bookmark" class="title">请高手进来指导下</a>
					<div>
						问题描述 请问在VS中,如果做WEB项目是不是不能用VC(托管的也可以)作为后台语言,我的VS中选择语言框中只有VB和C#.如果能请问如何做??困扰了我好多天的一个问题,请知道一定给我说下,谢谢了.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmKLLz.html" rel="bookmark" class="title">大型电子商务网站怎么实现图片的管理和显示</a>
					<div>
						问题描述 大型电子商务网站怎么实现图片的管理和显示 如题,大型电子商务网站怎么实现图片的管理和显示 我看到比如凡客用另外的域名组成url在网站中显示http://i2.vanclimg.com/use ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZxXab.html" rel="bookmark" class="title">同步和异步&comma; 阻塞和非阻塞&comma; Reactor和Proactor</a>
					<div>
						http://www.artima.com/articles/io_design_patterns.html http://note.sdo.com/u/1434409594/n/lvRFW~kjR2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6eajz.html" rel="bookmark" class="title">js跨域的研究</a>
					<div>
						在开发中总是会遇到,接入层可能去调用其它域名下服务的api,crud数据,可是在这中间会出现js的同源策略,导致同一个DOM不能用多个源加载数据,已确保安全性. 在数据远程调用的设计时候,要考虑性能又 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqjrKb.html" rel="bookmark" class="title">Garena黄智凯：Docker构建自动化运维</a>
					<div>
						文章讲的是Garena黄智凯:Docker构建自动化运维,本文根据[2016 第七届中国数据库技术大会](微信搜索DTCC2014,关注关注中国数据库技术大会公众号)现场演讲嘉宾黄智凯老师分享内容整理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBar0M.html" rel="bookmark" class="title">【阿里云资讯】MIT科技评论：阿里是大数据Game Changer</a>
					<div>
						阿里是大数据Game Changer 11月14日,&lt;麻省理工科技评论&gt;(MIT Technology Review)官网刊登文章&lt;Big Data Game-Changer: Al ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZdDWM.html" rel="bookmark" class="title">sql2005&plus;vs2008&lpar;C&num;&rpar;数据库应用软件开发</a>
					<div>
						问题描述 有关数据库操作的几个问题向大神们请教:1.使用sqlconnection对象连接数据库时,如果出现连接异常,则会出现上层程序卡死现象(此时,连接一直停在网卡?),这种现象应该怎么处理?2.s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLxB0p.html" rel="bookmark" class="title">Android仿Win8界面开发&lowbar;Android</a>
					<div>
						本文将要模仿Win8界面的一个设计,一个一个的方块.方法很简单.这里自己把图片改改就可以成为自己想要的界面了. 1.首先来看看自定义的MyImageView: package com.example. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLevZp.html" rel="bookmark" class="title">python读取注册表中值的方法&lowbar;python</a>
					<div>
						在Python的标准库中,_winreg.pyd可以操作Windows的注册表,另外第三方的win32库封装了大量的Windows API,使用起来也很方便.不过这里介绍的是使用_winreg操作注册 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pker9ob.html" rel="bookmark" class="title">Zookeeper核心工作机制（zookeeper特性、zookeeper数据结构、节点类型）</a>
					<div>
						10.1 zookeeper特性 1.Zookeeper:一个leader,多个follower组成的集群. 2.全局数据一致:每个server保存一份相同的数据副本,client无论连接到哪个ser ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/zOJwr5p.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vbW1iaXoucXBpYy5jbi9tbWJpei93YzdZTlBtM1l4VXY1bFZmaWNZZW1wVGNlcDN3OU55OFlTNTBBQ25MeUtMb0llczBGYzBtZDQ3MFloTGljckk5dWxGcGliajNUUFFpYnFKbFZRTzdzT3ZDMlEvMA==.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/zOJwr5p.html" rel="bookmark" class="title">Profusa：在体内与细胞共生的智能设备&period;&period;&period;</a>
					<div>
						植入式技术已有十几年的历史,发展至今,到目前为止最常见的是心脏起搏技术,耳蜗植入技术及仿生眼球,不过这三种都是针对病人,帮助他们稳定心脏跳动,助听以及恢复视力.针对疾病预测的植入式设备比较少见,在一次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq73LYz.html" rel="bookmark" class="title">如何在 Shell 脚本中执行语法检查调试模式</a>
					<div>
						我们开启了 Shell 脚本调试系列文章,先是解释了不同的调试选项,下面介绍如何启用 Shell 调试模式. 写完脚本后,建议在运行脚本之前先检查脚本中的语法,而不是查看它们的输出以确认它们是否正常工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBlWqz.html" rel="bookmark" class="title">互联网之父：开放Web并未消亡 原生应用走反了</a>
					<div>
						12月11日,据VentureBeat网站报道,最近数年应用快速普及,有关应用的兴起是否正在扼杀Web的争论此起彼伏.那么,Web真的&quot;死了&quot;吗? 在LeWeb 2014会议上发言 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44k6Lz.html" rel="bookmark" class="title">javascript中数组（Array&rpar;对象和字符串（String&rpar;对象的常用方法总结&lowbar;javascript技巧</a>
					<div>
						本文实例总结了javascript中数组(Array)对象和字符串(String)对象的常用方法.分享给大家供大家参考,具体如下: 综述:笔者经常将数组的方法和字符串的方法混淆,这里写篇日志,做个区分 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.082 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
